"""
	This class is designed to be an actor class i.e it will undertake certain actions given an event detected
	The platform has 2 main sections (detection & analysis).
	Action Types (Actors):
		- Alert : Sends an email or Webhook
		- Apps 	: Kill, Start
		- Folder: Archive, Delete (all, age, size)
        By design we are to understand that a message is structured as follows:
            {to,from,content} with content either being an arbitrary stream (or JSON)
	@TODO: 
		- upgrade to python 3.x
"""
import json
from threading import Thread
import os
import subprocess
from monitor import ProcessCounter
from utils.transport import QueueListener, QueueWriter
class Actor(Thread):
	def __init__(self,config):
		Thread.__init__(self)
		self.config = config
		self.items = []
		self.__id = config['id']
        def getIdentifier(self):
                return self.__id
            
	def init(self,litems):
		self.items = litems
	def process(self,item):
		pass
	def execute(self,cmd):
		stream = None
		try:
			handler = subprocess.Popen(cmd,shell=True,stdout=subprocess.PIPE)
			stream = handler.communicate()[0]
		except Exception,e:
			pass
		return stream
	def callback(self,channel,method,header,stream):
                print [self.getIdentifier(),stream]
                message = json.loads(stream)
                content = message['content']
                sender = message['from']
                self.post(to=sender,content=content)
                #message = None
                #try:
                    #message = json.loads(stream)
                #except Exception, e:
                    #pass
                #if message is not None:
                    #if 'id' in message :
                        #if 'payload' in message:
                            #self.execute(message['payload']
        """
            Sending a message to a queue with parameters to,from,content
        """
        def post(self,**args):
                to      = args['to'] 
                content = args['content']
                message = {"from":self.getIdentifier(),"to":to,"content":content}
                host	= self.config['api']
                uid	= self.config['key']
                qid	= to#self.config['id']
                print [host,uid,qid]
                qwriter = QueueWriter(host=host,uid=uid,qid=qid)
                qwriter.init(qid)
                qwriter.write(label=qid,row="got it")
                #qwriter.close()
                pass
	def run(self):
		info = {}
		host	= self.config['api']
		uid	= self.config['key']
		qid	= self.config['id']
		
		qlistener = QueueListener(qid=qid,uid=uid,host=host)		
		qlistener.callback = self.callback
		qlistener.read()
		r = [self.process(item) for item in self.items]
class Kill(Actor):
	def __init__(self,config):
		Actor.__init__(self,config)
	def process(self,item):
		cmd = "".join(["ps -eo pid,command|grep ",item,'|grep -E"^ {0,1}[0-9]+" -o|xargs kill -9'])
		self.execute(cmd)
		#
		# We need to make sure we can get assess the process on this server
		#
class Start(Actor):
	def __init__(self,config):
		Actor.__init__(self,config)
	def process(self,item):
		path = item['path']
		args = item['args'] if 'args' in item else ''
		cmd = " ".join([path,args])
		self.execute(cmd)
	
class Alert(Actor):
	pass

config = {"id":"demo","key":"[0v8]-247&7!v3","api":"localhost"}
actor = Kill(config)
actor.start()

config = {"id":"demo-100","key":"[0v8]-247&7!v3","api":"localhost"}
actor_1 = Kill(config)
actor_1.start()